// Declaration of the abstract base class, Dictionary, which describes
//  a generic interface for classes designed to implement a dictionary.
// t a y l o r@msoe.edu, 1-27-2004

#ifndef DICTIONARY_H
#define DICTIONARY_H

#include <string>

class Dictionary
{
public:
  // Default constructor
  Dictionary();
  // Copy constructor
  Dictionary(const Dictionary& org);
  // Destructor
  virtual ~Dictionary();
  // Assignment operator
  virtual Dictionary& operator=(const Dictionary& rhs);
  // Loads words from filename into the dictionary
  virtual bool loadDictionary(const std::string& filename) = 0;
  // Returns true if word is found in the dictionary
  virtual bool find(const std::string& word) const = 0;
};

#endif
