// Driver program that allows the use to spell check a file using one of
//  various dictionary implementations.
// t a y l o r@msoe.edu
// Note: This program is not complete and must be modified by each student
//       team.

#include "Dictionary.h"
#include "SetDictionary.h"
#include <string>
#include <iostream>
#include <fstream>

using std::string;
using std::cout;
using std::cin;

int main()
{
  string dictFilename;
  string userFilename;
  char selection = 'x';
  cout << "Enter the name of your dictionary file\n";
  cin >> dictFilename;
  // Display menu and get selection
  while(selection!='e' && (selection<'1' || selection>'3')) {
    cout << "Menu\n====\n";
    cout << "1. Set implementation\n";
    cout << "2. Roll your own vector (unsorted) implementation [non-functional]\n";
    cout << "3. Roll your own vector (sorted) implementation [non-functional]\n";
    // ...
    cout << "e. To exit without spell checking\n";
	cin >> selection;
  }
  if(selection!='e') {
    // Create a dictionary object pointer that can point to derived class objects
    Dictionary* dict = NULL;
    // Create the appropriate dictionary object (based on user selection)
    switch(selection) {
      case '1':
        dict = new SetDictionary;
        break;
      case '2':
        std::cerr << "Roll your own vector (unsorted) not implemented using set implementation\n";
        dict = new SetDictionary;
        break;
      case '3':
        std::cerr << "Roll your own vector (sorted) not implemented using set implementation\n";
        dict = new SetDictionary;
        break;
      default:
        std::cerr << "Invalid selection... using set implementation\n";
        dict = new SetDictionary;
        break;
    }
    dict->loadDictionary(dictFilename);
    std::ifstream fin;
    bool successfulOpen = false;
    while(!successfulOpen) {
      cout << "Enter the name of the file you wish to spell check\n";
      cin >> userFilename;
      fin.open(userFilename.c_str());
      if(fin) {
        successfulOpen = true;
      } else {
        fin.close();
        fin.clear();
      }
    }
    string word;
    cout << "Words not found in the dictionary:\n";
    while(fin>>word) {
      if(!dict->find(word)) {
        cout << word << '\n';
      }
    }
  }
  return EXIT_SUCCESS;
}
